SWDB = {
	Enabled = true,
	showClass = true,
	showRace = false,
	selfShow = true,
	oppOnly = false,
	chatFrame = 1,
}
local SWDBD = {
	Enabled = true,
	showClass = true,
	showRace = false,
	selfShow = true,
	oppOnly = false,
	chatFrame = 1,
	}
	
local defaultBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4,}
}
local optionsBackdrop = {
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
}	
local horde = {"Orc", "Tauren", "Scourge", "Troll", "BloodElf", "Goblin"}
local alliance = {"Human", "Dwarf", "NightElf", "Gnome", "Draenei", "Worgen"}
local selfFaction, localizedFaction = UnitFactionGroup("player")
local SW = "|cffe1a500Stealth|cff69ccf0Watch|cffffffff"
local ver = GetAddOnMetadata("StealthWatch","Version")

local function infoCheck(guid)
	if not guid then return end
	local localizedClass, fileClass, localizedRace, fileRace, _ = GetPlayerInfoByGUID(guid)
	local faction
	local r,g,b = 0,0,0
	local class,race
	local run = true
	for k,v in pairs(horde) do if (v==fileRace) then r,g,b = 1,0,0; faction = "Horde" end end
	for k,v in pairs(alliance) do if (v==fileRace) then r,g,b = 0.41,0.8,0.94; faction = "Alliance" end end
	if (SWDB.showClass==true) then class = (" ("..localizedClass..")") else class = ("") end
	if (SWDB.showRace==true) then race = (" ("..localizedRace..")") else race = ("") end
	if (SWDB.oppOnly==true) then if (faction==selfFaction) then run = false elseif (faction~=selfFaction) then run = true end end
	return r,g,b,class,race,run
end

local OnEvent = CreateFrame("Frame")
OnEvent:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14)
	if (event=="ADDON_LOADED") then
		if (arg1=="StealthWatch") then for k,v in pairs(SWDBD) do if SWDB[k] == nil then SWDB[k] = SWDBD[k] end end end
	elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then
		if (arg2=="SPELL_CAST_SUCCESS") then
			if (arg12==1784) or (arg12==1856) or (arg12==114018) or (arg12==5215) or (arg12==66) or (arg12==110959) or (arg12==58984) or (arg12==51753) or (arg12==3823) or (arg12==9172) or (arg12==156136) then
				if (arg5==UnitName("player")) and (SWDB.selfShow==false) then
					return
				else
					if (arg12==1784) then -- Stealth
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cff71d5ff\124Hspell:1784\124h[Stealth]\124h\124r",r,g,b) end
					elseif (arg12==1856) then -- Vanish
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cff71d5ff\124Hspell:1856\124h[Vanish]\124h\124r",r,g,b) end
					elseif (arg12==114018) then -- Shroud of Concealment
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cffffd000\124Hspell:114018\124h[Shroud of Concealment]\124h\124r",r,g,b) end
					elseif (arg12==5215) then -- Prowl
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cff71d5ff\124Hspell:5215\124h[Prowl]\124h\124r",r,g,b) end
					elseif (arg12==66) then -- Mage Invisibility
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cff71d5ff\124Hspell:66\124h[Invisibility]\124h\124r",r,g,b) end
					elseif (arg12==110959) then -- Mage Greater Invisibility
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cffffd000\124Hspell:110959\124h[Greater Invisibility]\124h\124r",r,g,b) end
					elseif (arg12==58984) then -- Shadowmeld
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cff71d5ff\124Hspell:58984\124h[Shadowmeld]\124h\124r",r,g,b) end
					elseif (arg12==51753) then -- Camouflage
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has cast \124cff71d5ff\124Hspell:51753\124h[Camouflage]\124h\124r",r,g,b) end
					elseif (arg12==3823) then -- Potion: Lesser Invisibility
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has used a \124cffffffff\124Hitem:3823:0:0:0:0:0:0:0:0\124h[Lesser Invisibility Potion]\124h\124r",r,g,b) end
					elseif (arg12==9172) then -- Potion: Invisibility
						local r,g,b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has used an \124cffffffff\124Hitem:9172:0:0:0:0:0:0:0:0\124h[Invisibility Potion]\124h\124r",r,g,b) end
					elseif (arg12==156136) then -- Stealthman 54
						local r, g, b,class,race,run = infoCheck(arg4)
						if (run==true) then _G["ChatFrame"..SWDB.chatFrame]:AddMessage(arg5..class..race.." has used a \124cffffffff\124Hitem:109184::::::::110:::::\124h[Stealthman 54]\124h\124r",r,g,b) end
					end
				end
			end
		end		
		
	end
end)
OnEvent:RegisterEvent("ADDON_LOADED")
if (SWDB.Enabled == true) then OnEvent:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") end

SLASH_STEALTHW1 = '/stealthw'
SLASH_STEALTHW2 = '/stw'
function SlashCmdList.STEALTHW(msg, editbox)
	if (msg=="on") then
		if (SWDB.Enabled == false) then
			OnEvent:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			SWDB.Enabled = true
			print(SW.." has been Enabled.")
		else
			print(SW.." is already Enabled.")
		end
	elseif (msg=="off") then
		if (SWDB.Enabled == true) then
			OnEvent:UnregisterAllEvents()
			SWDB.Enabled = false
			print(SW.." has been disabled.")
		else
			print(SW.." is already disabled.")
		end
	else
		SWOP:Show()
	end
end

local function chatFrameCheck(enteredName)
	local changed = false
	for i = 1, NUM_CHAT_WINDOWS do
		local name = GetChatWindowInfo(i)
		if ((string.lower(name))==(string.lower(enteredName))) then
			SWDB.chatFrame = i
			print(SW..": Print chatframe changed to "..name)
			chatFrameEdit:SetText(name)
			changed = true
		end
	end
	if (changed==false) then
		print(SW..": No valid chatframe name was entered.")
		local oldName = GetChatWindowInfo(SWDB.chatFrame)
		chatFrameEdit:SetText(oldName)
	end
end

local function checkUpdate()
	sw_enableCheck:SetChecked(SWDB.Enabled)
	sw_classCheck:SetChecked(SWDB.showClass)
	sw_raceCheck:SetChecked(SWDB.showRace)
	sw_selfCheck:SetChecked(SWDB.selfShow)
	sw_oppCheck:SetChecked(SWDB.oppOnly)
	local curChatFrame = GetChatWindowInfo(SWDB.chatFrame)
	chatFrameEdit:SetText(curChatFrame)
end

local SWOP = CreateFrame("Frame", "SWOP", UIParent) -- StealthWatch Options Panel (Awesome acronym, I know!)
SWOP:SetBackdrop(optionsBackdrop)
SWOP:SetBackdropColor(0.1,0.1,0.1,0.9)
SWOP:SetSize(210,225)
SWOP:SetPoint("CENTER", UIParent)
SWOP:EnableMouse(true)
SWOP:SetMovable(true)
SWOP:SetScript("OnMouseDown", function(self, button) if (button=="LeftButton") then self:StartMoving() end end)
SWOP:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
SWOP:Hide()
SWOP:SetScript("OnShow", function(self) checkUpdate() end)
local header = SWOP:CreateTexture("ARTWORK")
header:SetPoint("CENTER", SWOP, "TOP", 0, -16)
header:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
header:SetSize(256, 64)
local headerText = SWOP:CreateFontString("headerText", "OVERLAY", "ChatFontSmall")
headerText:SetPoint("CENTER", header, "TOP", 0, -20)
headerText:SetText(SW.." Options")
----------------
-- Inside
----------------
local SWOP1 = CreateFrame("Frame", "SWOP1", SWOP)
SWOP1:SetBackdrop(defaultBackdrop)
SWOP1:SetBackdropColor(0.1,0.1,0.1,0.9)
SWOP1:SetBackdropBorderColor(1,1,1,0.9)
SWOP1:SetPoint("TOP", SWOP, "TOP",0,-20)
SWOP1:SetSize(190,170)
local sw_enableCheck = CreateFrame("CheckButton", "sw_enableCheck", SWOP1, "UICheckButtonTemplate")
sw_enableCheck:SetPoint("TOPLEFT", SWOP1, "TOPLEFT",10,-10)
sw_enableCheck:SetSize(20,20)
sw_enableCheck:SetScript("OnClick", function(self) if (SWDB.Enabled==false) then SWDB.enabled = true else SWDB.enabled = false end end)
local sw_enableText = SWOP1:CreateFontString("sw_enableText", "OVERLAY", "ChatFontSmall")
sw_enableText:SetPoint("LEFT", sw_enableCheck, "RIGHT")
sw_enableText:SetText("Enable StealthWatch")
local sw_classCheck = CreateFrame("CheckButton", "sw_classCheck", SWOP1, "UICheckButtonTemplate")
sw_classCheck:SetPoint("TOP", sw_enableCheck, "BOTTOM",0,-5)
sw_classCheck:SetSize(20,20)
sw_classCheck:SetScript("OnClick", function(self) if (SWDB.showClass==false) then SWDB.showClass = true else SWDB.showClass = false end end)
local sw_classText = SWOP1:CreateFontString("sw_classText", "OVERLAY", "ChatFontSmall")
sw_classText:SetPoint("LEFT", sw_classCheck, "RIGHT")
sw_classText:SetText("Show player's class")
local sw_raceCheck = CreateFrame("CheckButton", "sw_raceCheck", SWOP1, "UICheckButtonTemplate")
sw_raceCheck:SetPoint("TOP", sw_classCheck, "BOTTOM",0,-5)
sw_raceCheck:SetSize(20,20)
sw_raceCheck:SetScript("OnClick", function(self) if (SWDB.showRace==false) then SWDB.showRace = true else SWDB.showRace = false end end)
local sw_raceText = SWOP1:CreateFontString("sw_raceText", "OVERLAY", "ChatFontSmall")
sw_raceText:SetPoint("LEFT", sw_raceCheck, "RIGHT")
sw_raceText:SetText("Show player's race")
local sw_selfCheck = CreateFrame("CheckButton", "sw_selfCheck", SWOP1, "UICheckButtonTemplate")
sw_selfCheck:SetPoint("TOP", sw_raceCheck, "BOTTOM",0,-5)
sw_selfCheck:SetSize(20,20)
sw_selfCheck:SetScript("OnClick", function(self) if (SWDB.selfShow==false) then SWDB.selfShow = true else SWDB.selfShow = false end end)
local sw_selfText = SWOP1:CreateFontString("sw_selfText", "OVERLAY", "ChatFontSmall")
sw_selfText:SetPoint("LEFT", sw_selfCheck, "RIGHT")
sw_selfText:SetText("Show your own stealthing")
local sw_oppCheck = CreateFrame("CheckButton", "sw_oppCheck", SWOP1, "UICheckButtonTemplate")
sw_oppCheck:SetPoint("TOP", sw_selfCheck, "BOTTOM",0,-5)
sw_oppCheck:SetSize(20,20)
sw_oppCheck:SetScript("OnClick", function(self) if (SWDB.oppOnly==false) then SWDB.oppOnly = true else SWDB.oppOnly = false end end)
sw_oppCheck:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT"); GameTooltip:SetText("|cffff0000NOTE:|cffffffff This will override the above option!"); GameTooltip:Show(); end)
sw_oppCheck:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
local sw_oppText = SWOP1:CreateFontString("sw_oppText", "OVERLAY", "ChatFontSmall")
sw_oppText:SetPoint("LEFT", sw_oppCheck, "RIGHT")
sw_oppText:SetText("Show only enemy players")
local chatFrameText = SWOP1:CreateFontString("chatFrameText", "OVERLAY", "ChatFontSmall")
chatFrameText:SetPoint("TOPLEFT", sw_oppCheck, "BOTTOMRIGHT",0,-5)
chatFrameText:SetText("Print to:")
local chatFrameEdit = CreateFrame("EditBox", "chatFrameEdit", SWOP1)
chatFrameEdit:SetSize(100,20)
chatFrameEdit:SetPoint("LEFT", chatFrameText, "RIGHT",2,0)
chatFrameEdit:SetTextInsets(2, 0, 0, 0)
chatFrameEdit:IsMultiLine(false)
chatFrameEdit:SetAutoFocus(false)
chatFrameEdit:SetText("General")
chatFrameEdit:SetFontObject("GameFontNormalSmall")
chatFrameEdit:SetMaxBytes(30)
chatFrameEdit:SetScript("OnEnterPressed", function(self)
	chatFrameEdit:ClearFocus()
	chatFrameCheck(chatFrameEdit:GetText())
end)
local chatFrameText2 = SWOP1:CreateFontString("chatFrameText2", "OVERLAY", "ChatFontSmall")
chatFrameText2:SetPoint("TOP", chatFrameEdit, "BOTTOM")
chatFrameText2:SetText("(Chatframe name)")

local closeButton = CreateFrame("Button", "closeButton", SWOP, "OptionsButtonTemplate")
closeButton:SetPoint("BOTTOMRIGHT", SWOP, "BOTTOMRIGHT", -10,10)
closeButton:SetScript("OnClick", function(self) SWOP:Hide() end)
closeButton:SetSize(65,20)
closeButton:SetText("Close")
local footer = CreateFrame("Frame", "footer", SWOP)
footer:SetPoint("BOTTOMLEFT", SWOP, "BOTTOMLEFT",10,10)
footer:SetBackdrop(defaultBackdrop)
footer:SetBackdropColor(0.1,0.1,0.1,0.9)
footer:SetBackdropBorderColor(1,1,1,0.9)
footer:SetSize(120,22)
local verText = footer:CreateFontString("verText", "OVERLAY", "ChatFontSmall")
verText:SetPoint("LEFT", footer, "LEFT",10,0)
verText:SetText("|cffe1a500Version |cffffffff"..ver)




